#COPYRIGHT (c) 2007 shagon
#FILENAME:PrimeNum.py
#COMPILER:PythonWin
#DEBUG ON Series 60 C++ SDKs
#TESTED ON MY NOKIA6670
#DATE:Sep 19th,2007

# -*- coding:utf-8 -*- 
import appuifw
import e32
appuifw.app.screen='full' 
appuifw.app.title='质数判定'.decode("utf-8")
appuifw.app.body = appuifw.Text('\n\n\n\n\n感谢使用质数判定(shagon出品)\n\n点击左软键可呼出菜单\n'.decode("utf-8"))
app_lock = e32.Ao_lock()
def exit_key_handler():
    app_lock.signal()
def calculate():
    while 1:
        number_enter = appuifw.query('输入整数: '.decode("utf-8"),"number")
        if number_enter<=0:
            appuifw.note('输入有误'.decode("utf-8"),"error")
        else:
            break
    if number_enter==1:
        appuifw.app.body=appuifw.Text('\n\n1 不是质数也不是合数\n-------\n运算完毕'.decode("utf-8"))
    elif number_enter==2:
        appuifw.app.body=appuifw.Text('\n\n2 是质数\n-------\n运算完毕'.decode("utf-8"))
    else:
        is_prinum=1
        for i in range(2,number_enter):
            if number_enter % i==0:
                is_prinum=0
                break
            if i*i>number_enter:
                break            
            if i%2==0:
                continue
        if is_prinum==1:
            appuifw.app.body=appuifw.Text(u"\n\n"+str(number_enter)+' 是质数\n-------\n运算完毕'.decode("utf-8"))
        else:
            temp=number_enter            
            for x in range(2,number_enter):
                if temp % x==0:
                    temp=temp/x
                    last_loop=x
                    result=str(x)
                    break
                if x*x>temp:
                    break
                if x%2==0 and x>2:
                    continue
            for x in range(last_loop,number_enter):
                if temp==1:  
                    break
                if temp%x==0:
                    temp=temp/x
                    result=result+"x"+str(x)
                    while temp%x==0:
                        temp=temp/x
                        result=result+"x"+str(x)
                if x*x>temp:
                    break
                if x%2==0:
                    continue
        if temp>1: result=result+"x"+str(temp)
        appuifw.app.body=appuifw.Text(u"\n\n"+str(number_enter)+' 是合数\n质因数分解为：\n'.decode("utf-8")+result+'\n-------\n运算完毕'.decode("utf-8"))
def prinum_exit():
    appuifw.app.set_exit()
def about_info():
    appuifw.note('杜俊/shagon作品 \n www.cnpda.com.cn \n 2007.09.19'.decode("utf-8"), "info") 
appuifw.app.menu = [('质数判定'.decode("utf-8"), calculate),
                    ('关于作者'.decode("utf-8"), about_info),
                    ('退出软件'.decode("utf-8"), prinum_exit)]
app_lock.wait()